## Сборка своей собственной golos-lib-js

Вы можете собрать свою собственную копию golos-lib-js, чтобы дополнительно проаудировать ее, или, к примеру, доработать для использования в специфических проектах\задачах.

1. Установите [Node 16+](https://nodejs.org/en/download).
   
2. Установите yarn:
```js
npm install -g yarn
```
Если вы не можете выполнить эту команду, но Node.js установлен, то нужно в переменную PATH добавить путь к `node` и `npm`.

3. Скачайте golos-lib-js нужной версии (`master` - последняя стабильная версия):
```sh
git clone https://github.com/golos-blockchain/libs -b master
```
Если вы не можете выполнить эту команду, установите [Git](https://git-scm.com/).

4. Соберите golos-lib-js:
```js
cd libs
cd golos-lib-js
yarn install
yarn run build
```

5. Если сборка успешна, вы можете проверить корректность сборки с помощью тестов:
```js
yarn run test
```
Если ошибок нет, то вероятно сборка прошла без проблем.

6. При локальной работе со своим проектом вы можете добавлять библиотеку в проект следующим образом:
```js
yarn add /root/libs/golos-lib-js
```
или
```js
npm install /root/libs/golos-lib-js
```
где `/root/libs/golos-lib-js` - полный путь к библиотеке, **собранной** согласно пункту 4.

### Публикация в npm

Чтобы использовать свою сборку golos-lib-js в своих проектах (или своих форках наших проектов), обычно нужно опубликовать ее в npm и использовать оттуда.

1. Создайте аккаунт на https://www.npmjs.com/ если его у вас еще нет.
2. Войдите в него, выполнив команду:
```sh
npm login
```
Потребуется ввести имя аккаунта, пароль, e-mail, и (если вы не настроили иное) одноразовый пароль, который придет на e-mail.
3. Переименуйте свой форк библиотеки, например: `alice-golos-lib-js`
Проверьте, что такой библиотеки еще нет: https://www.npmjs.com/package/alice-golos-lib-js - здесь должно быть 404 not found
4. Снова соберите библиотеку (`yarn build`)
5. **ВАЖНО: удалите зависимости**, то есть папку `node_modules`, мы тоже удаляем е перед загрузкой, поскольку она не покрывается контрол-хешем библиотеки.
6. Выполните команду
```sh
npm publish
```
7. После этого вы можете удалить библиотеку golos-lib-js из проекта:
```sh
yarn remove golos-lib-js
```
и установить свой форк взамен
```sh
yarn add alice-golos-lib-js
```
при этом во всех файлах кода надо поменять "golos-lib-js" на "alice-golos-lib-js".
