"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _events = _interopRequireDefault(require("events"));
var _config = _interopRequireDefault(require("../../config"));
var _promisify = require("../../promisify");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
class Transport extends _events.default {
  constructor() {
    let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    super(options);
    this.options = options;
    this.id = 0;
    this.releases = [];
    this.requests = {};
    this.callbacks = {};
  }
  setOptions(options) {
    Object.assign(this.options, options);
    this.stop();
  }
  getURL() {
    const url = this.options && this.options.url;
    return url || _config.default.get('websocket');
  }
  listenTo(target, eventName, callback) {
    if (target.addEventListener) target.addEventListener(eventName, callback);else target.on(eventName, callback);
    return () => {
      if (target.removeEventListener) target.removeEventListener(eventName, callback);else target.removeListener(eventName, callback);
    };
  }
  send() {}
  start() {}
  stop() {}
}
exports.default = Transport;
(0, _promisify.promisifyAll)(Transport.prototype);