"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _crossFetch = _interopRequireDefault(require("cross-fetch"));
var _abortController = _interopRequireDefault(require("abort-controller"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
const COMMON_TIMEOUT = 10000;
async function fetchEx(url, opts) {
  let {
    timeout,
    ...restOpts
  } = opts;
  if (!restOpts.signal) {
    if (timeout === 0 || timeout === undefined) {
      timeout = COMMON_TIMEOUT;
    }
    if (timeout !== null) {
      const controller = new _abortController.default();
      setTimeout(() => controller.abort(), timeout);
      restOpts.signal = controller.signal;
    }
  }
  return await (0, _crossFetch.default)(url, restOpts);
}
fetchEx.COMMON_TIMEOUT = COMMON_TIMEOUT;
fetchEx.AbortController = _abortController.default;
var _default = exports.default = fetchEx;